/*
	$Id: AbstractMethods.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ֥ȥ饯ȥ᥽åɤΥåȤǤ
*/
public class AbstractMethods {

    /** ؿΥꥹ */
    protected LinkedList<Method> v;

    /**
       ֥ȥ饯ȥ᥽åɤΥåȤޤ

       @param gm 롼ץޥ͡
       @param nodes ֥ȥ饯ȥ᥽åɤΥΡɥꥹ
    */
    public AbstractMethods(final GroupManager gm, final NodeList nodes) {
	v = new LinkedList<Method>();

	if (nodes == null) {
	    return;
	}
	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    Method m = gm.createMethod(elem);
	    v.add(m);
	}
    }

    /**
       ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    protected void printSummaryHeader(final PrintWriter wr) {
	wr.println("<h2>Abstract Method Summary</h2>");
    }

    /**
       ܺ٤ΥإåHTMLǽϤޤ

       @param wr 饤
    */
    protected void printDetailHeader(final PrintWriter wr) {
	wr.println("<h2>Abstract Method Detail</h2>");
    }

    /**
       ܺ٤ΥإåTeXǽϤޤ

       @param wr 饤
    */
    protected void printTexDetailHeader(final PrintWriter wr) {
	wr.println("\\Sabstractmethod");
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printSummaryHeader(wr);
	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">");
	for (Method m : v) {
	    m.printSummary(wr);
	}
	wr.println(""
+ "    </table>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printDetailHeader(wr);
	for (Method m : v) {
	    m.printDetail(wr);
	    wr.println("<hr>");
	}
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	printTexDetailHeader(wr);
	for (Method m : v) {
	    m.printTexDetail(wr);
	}
    }
}
