/*
	$Id: StructUnionMember.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
   ¤ΤΥФޤ϶ΤΥФΤstructޤunionΥ
   ФǤ

   Υ饹ɽФStructUnionФȸƤӤޤΥФο
   Ϲ¤Τޤ϶ΤǤ

   structmemberǡunionmemberǤбޤ
*/
public class StructUnionMember extends CompoundMember {

    /**
       StructUnionФޤ

       @param gm 롼ץޥ͡
       @param parentName Ƥ̾
       @param label "struct" ޤ "union"
       @param elem structmemberǤޤunionmember
    */
    public StructUnionMember(final GroupManager gm, final String parentName,
			     final String label, final Element elem) {
	super(parentName, elem);

	String implName;
	if (type.equals("struct") || type.equals("union")) {
	    implName = "@" + IDManager.getInstance().getUniqueID();
	    setDescType(type + " " + implName);
	} else if (type.startsWith("struct ") || type.startsWith("union ")) {
	    int k = type.indexOf(' ');
	    implName = type.substring(k + 1).trim();
	} else {
	    throw new RuntimeException("value of type attribute '"
				       + type
				       + "' is invalid.");
	}
	setCompoundImpl(new CompoundImpl(gm, label, elem, implName,
					 getDescType()) {
	    protected String getTagName() {
		return StructUnion.TAG_NAME;
	    }
	    protected Components getComponents(final GroupManager gm,
					       final String descType,
					       final NodeList nodes) {
		return new Members(gm, descType, nodes);
	    }
	});
    }
}
