/*
	$Id: Parameter.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   Ǥ

   parameterǤбޤ
*/
public class Parameter {

    /** type° */
    private String type;

    /** name° */
    private String name;

    /** descǤ */
    private Description desc;

    /**
       ޤ

       @param elem parameter
    */
    public Parameter(final Element elem) {
	type = elem.getAttribute("type");
	name = elem.getAttribute("name");

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ɽʸޤ

       type°#ޤޤ硢Ƭ#name°Ƥִ
       Τ֤ޤǤʤСtype°name°Ƥ
       Ϣ뤷Τ֤ޤ

       @return ɽʸ
    */
    public String getCode() {
	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", name);
	} else {
	    return type + " " + name;
	}
    }

    /**
       ηɽʸޤ

       type°#ޤޤ硢Ƭ#Τ֤
       ǤʤСtype°Ƥ֤ޤ

       @return ηɽʸ
    */
    public String getType() {
	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", "");
	} else {
	    return type;
	}
    }

    /**
       ̾ɽʸޤ

       @return ̾ɽʸ
    */
    public String getName() {
	return name;
    }

    /**
       ɽHTMLʸޤ

       getCode()ʸHTMLǽΤ֤ޤ

       @return ɽHTMLʸ
       @see #getCode
    */
    public String getText() {
	String argName = "<i>" + name + "</i>";

	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", argName);
	} else {
	    return type + "&nbsp;" + argName;
	}
    }

    /**
       ɽTeXʸޤ

       getCode()ʸTeXǽΤ֤ޤ

       @return ɽTeXʸ
       @see #getCode
    */
    public String getTexText() {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";
	String texType = Tex.safe(type);

	if (texType.indexOf('#') != -1) {
	    return texType.replaceFirst("#", "\\" + argName);
	} else {
	    return texType + " " + argName;
	}
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<i>" + name + "</i> - " + desc.getText() + "<br>\n");
   }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";

	wr.println(""
+ "\\item[" + argName + "] " + desc.getTexText());
   }
}
