/*
	$Id: Parameters.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ΥåȤǤ

   ᥽åɤΤ٤Ƥΰݻޤ
*/
public class Parameters {

    /** Υꥹ */
    private LinkedList<Parameter> v;

    /**
       ΥåȤޤ

       @param nodes ΥΡɥꥹ
    */
    public Parameters(final NodeList nodes) {
	v = new LinkedList<Parameter>();

	if (nodes == null) {
	    return;
	}
	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    v.add(new Parameter(elem));
	}
    }

    /**
       ٤Ƥΰɽʸޤ

       ץȥΰʬʸǤ

       @return ٤Ƥΰɽʸ
    */
    public String getCode() {
	String s = "", token = "";
	for (Parameter m : v) {
	    s += token + m.getCode();
	    token = ", ";
	}
	return (v.size() == 0) ? "void" : s;
    }

    /**
       ٤ƤΰɽHTMLʸޤ

       @return ٤ƤΰɽHTMLʸ
    */
    public String getText() {
	String s = "", token = "";
	for (Parameter m : v) {
	    s += token + m.getText();
	    token = ", ";
	}
	return (v.size() == 0) ? "void" : s;
    }

    /**
       ꤷֹΰޤ

       @param k ֹ
       @return 
    */
    public Parameter getParameter(final int k) {
	if (k >= v.size()) {
	    return null;
	}
	return v.get(k);
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println(""
+ "<dl>Parameters:<dd>");
	for (Parameter m : v) {
	    m.printDetail(wr);
	}
	wr.println(""
+ "</dd></dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("\\Sparameter");
	wr.println("\\begin{Sindentation}{\\Sindentlength}{0pt}");
	wr.println("\\begin{description}");
	for (Parameter m : v) {
	    m.printTexDetail(wr);
	}
	wr.println("\\end{description}");
	wr.println("\\end{Sindentation}");
    }
}
